#ifndef LEVEL_H
#define LEVEL_H

#include <list>
#include "drawEngine.h"
//#include "hovedvindu.h"
//class Hovedvindu;
using std::list;

class Sprite; 

class Hovedperson;

enum BLOCKS
{
	BLOCK_EMPTY = 0,
	BLOCK_FULL
};

enum SPRITES
{
	SPRITE_PLAYER = 0,
	SPRITE_ENEMY,
	SPRITE_VAPEN,
	SPRITE_PLAYERMULTI
};

enum toolIDS
{	
	TOOL_VISK,
	TOOL_VEGG,
	TOOL_SPILLER,
	TOOL_FIENDE,
	TOOL_EMPTY,
	
};

class Level
{
public:
	// Random
	Level(DrawEngine *de, int width = 40, int height = 20);
	// Load
	Level(DrawEngine *de, char **mapdata, int width, int height);
	~Level();

	void lagFiende(int antall, int fart = 10);
	void nonPC(Sprite *s);
	void nySpiller(Hovedperson *point, int num);
	int update(long time);
	void draw(void);
	bool keyPress(char c);
	friend class Sprite;
	friend class Vapen;
	list <Sprite *> npc;
	list <Sprite *>::iterator Iterator_npc;
	int getWidth(void);
	int getHeight(void);
	void settSpillerReset(int spillernr);
    int numEnemies(void);
	char **level;
	void setantallspillere(int nommer);
	int getAntallSpillere(void);


protected:
	void createLevel(void);
	//char **level;
	

private:
	int width;
	int height;
	int random_number;
	int startX;
	int startY;
	int startX2;
	int startY2;
	int goal;
	
	int antallspillere;

	Hovedperson *spiller;
	Hovedperson *spiller2;
	DrawEngine *tegn;
	Sprite *sprite_ptn;
	DrawEngine *drawe;
	//Hovedvindu *hovedvinduptr;



	
};

#endif
